--[[
PSP eMail and SMS by cools
( Thanks to Soadnation for the Analog Stick Info! )
]]--

oldpad = Controls.read()
white = Color.new(255, 255, 255)
black = Color.new(0,0,0)
red = Color.new(255,0,0)

dofile("danzeffarray.lua")
dofile("netlib.lua")

keys = Image.load("./graphics/keys.png")
keys_c = Image.load("./graphics/keys_c.png")
keys_s = Image.load("./graphics/keys_s.png")
keys_s_c = Image.load("./graphics/keys_s_c.png")
nums = Image.load("./graphics/nums.png")
nums_c = Image.load("./graphics/nums_c.png")
nums_s = Image.load("./graphics/nums_s.png")
nums_s_c = Image.load("./graphics/nums_s_c.png")

keyopt = 1
selectpad = standletters
stringnum = 1
danzeffopt = keys_s
selector = 5
innerChoice = 1

to = ""
from = ""
subject = ""
message = ""

background = Image.load("background.png")
selectorp = Image.load("selector.png")

-- - - - - - - - - - - - - - - - - - - - - -
--Displays the boxes in the correct places and other...
function danzeff()

	--Up/Down/Left/Right
		--Right
	if analogX > 32 and analogY > -40 and analogY < 40 then
		screen:blit(106,53,danzeffopt,128,64,63,63)
		stringnum = 6
	end
		--Left
	if analogX < -32 and analogY > -40 and analogY < 40 then
		screen:blit(0,53,danzeffopt,0,64,63,63)
		stringnum = 4
	end
		--Down
	if analogY > 32 and analogX < 40 and analogX > -40 then
		screen:blit(53,105,danzeffopt,64,128,63,63)
		stringnum = 8
	end
		--Up
	if analogY < -32 and analogX < 40 and analogX >-40 then
		screen:blit(53,0,danzeffopt,64,0,63,63)
		stringnum = 2
	end
		--Center
	if analogY > -32 and analogY <32 and analogX < 32 and analogX > -32 then
		screen:blit(53,53,danzeffopt,64,64,63,63)
		stringnum = 5
	end

	--Diagnals
		--Up/Right
	if analogY < -32 and analogX > 40 then
		screen:blit(106,0,danzeffopt,128,0,63,63)
		stringnum = 3
	end
		--Up/Left
	if analogY < -32 and analogX < -40 then
		screen:blit(0,0,danzeffopt,0,0,63,63)
		stringnum = 1
	end
		--Down/Right
	if analogY > 32 and analogX > 40 then
		screen:blit(106,105,danzeffopt,128,128,63,63)
		stringnum = 9
	end
		--Down/Left
	if analogY > 32 and analogX < -40 then
		screen:blit(0,105,danzeffopt,0,128,63,63)
		stringnum = 7
	end
end

-- - - - - - - - - - - - - - - - - - - - - -
--Returns whether two controller buttons are the same

function compareControllers(controller1, controller2) -- lua adaptation
	if (controller1:square() ~= controller2:square()) then
		return false
	elseif (controller1:triangle() ~= controller2:triangle()) then
		return false
	elseif (controller1:circle() ~= controller2:circle()) then
		return false
	elseif (controller1:cross() ~= controller2:cross()) then
		return false
	elseif (controller1:up() ~= controller2:up()) then
		return false
	elseif (controller1:down() ~= controller2:down()) then
		return false
	elseif (controller1:left() ~= controller2:left()) then
		return false
	elseif (controller1:right() ~= controller2:right()) then
		return false
	elseif (controller1:start() ~= controller2:start()) then
		return false
	elseif (controller1:select() ~= controller2:select()) then
		return false
	elseif (controller1:l() ~= controller2:l()) then
		return false
	elseif (controller1:r() ~= controller2:r()) then
		return false
	end
	return true
end

-- - - - - - - - - - - - - - - - - - - - - -
--Determines what button has been pressed and returns the letter

function Input(pad)

pressed = 1

if (not compareControllers(oldpad, pad)) then
   if pad:cross() or pad:circle() or pad:triangle() or pad:square() then

      if (pad:triangle()) then innerChoice = 1
         elseif pad:square() then innerChoice = 2
         elseif pad:cross() then innerChoice = 3
         elseif pad:circle() then innerChoice = 4
      end
   
pressed = string.byte(string.sub(selectpad[stringnum], innerChoice, innerChoice))

   end
end

oldpad = pad

return pressed
end
-- - - - - - - - - - - - - - - - - - - - - -
--Delays in Milliseconds
function delay( milli )
	vs=math.floor(milli/60)
	screen.waitVblankStart( vs )
end

-- - - - - - - - - - - - - - - - - - - - - -
--To
function to_input()
if (textString ~= 0 and textString ~= 1 and textString ~= 2) then
	if (textString == 8 or textString == string.byte("\010")) then 
		to = string.sub(to,1,(string.len(to)-1)) 
	elseif (textString == 13) then 
		to = ""
	elseif (textString == 4) then
		return 
	else
		to = to .. string.char(textString)
	end
end
end
-- - - - - - - - - - - - - - - - - - - - - -
--From
function from_input()
if (textString ~= 0 and textString ~= 1 and textString ~= 2) then
	if (textString == 8 or textString == string.byte("\010")) then 
		from = string.sub(from,1,(string.len(from)-1)) 
	elseif (textString == 13) then 
		from = ""
	elseif (textString == 4) then
		return 
	else
		from = from .. string.char(textString)
	end
end
end
-- - - - - - - - - - - - - - - - - - - - - -
--Subject
function subject_input()
if (textString ~= 0 and textString ~= 1 and textString ~= 2) then
	if (textString == 8 or textString == string.byte("\010")) then 
		subject = string.sub(subject,1,(string.len(subject)-1)) 
	elseif (textString == 13) then 
		subject = ""
	elseif (textString == 4) then
		return 
	else
		subject = subject .. string.char(textString)
	end
end
end
-- - - - - - - - - - - - - - - - - - - - - -
--Message
function message_input()
if (textString ~= 0 and textString ~= 1 and textString ~= 2) then
	if (textString == 8 or textString == string.byte("\010")) then 
		message = string.sub(message,1,(string.len(message)-1)) 
	elseif (textString == 13) then 
		message = ""
	elseif (textString == 4) then
		return 
	else
		message = message .. string.char(textString)
	end
	
end
end
-- - - - - - - - - - - - - - - - - - - - - -
--Options
function Options()
sendopt = 1
	while true do
		screen:fillRect(110,60,260,152,black)
		screen:print(120,70,"Send eMail",white)
		screen:print(120,80,"Send SMS",white)
		pad = Controls.read()
		if pad:up() then sendopt = 1 end
		if pad:down() then sendopt = 2 end
		if pad:triangle() then break end
		if sendopt == 1 then
			screen:print(120,70,"Send eMail",red)
			if to == "" or from == "" or subject == "" or message == "" then
				screen:print(120,90,"Fill in all Fields, Can't Send!",white)
			end
			if pad:cross() then
				netmail(to,from,subject,message) screen:print(120,90,"Message Sent",white) Wlan.term() break
			end
		end
		
		if sendopt == 2 then
			screen:print(120,80,"Send SMS",red)
				if to == "" or message == "" or from == "" then
					screen:print(120,90,"Fill in Fields, Can't Send!",white)
				end
				if string.len(to) ~= 10 and string.find(to,"%d") ~= "%d" then
					screen:print(120,100,"To Must be 10 Digits Long!",white)
				end
			if pad:cross() then
				netsms(to,message,from) screen:print(120,90,"Message Sent",white) Wlan.term() break
			end
		end
		screen.waitVblankStart()
		screen.flip()
	if pad:triangle() then Wlan.term() break end
end
end
-- - - - - - - - - - - - - - - - - - - - - -
while true do
	screen:blit(0,0,background)
	screen:blit(10,10,keys)
	pad = Controls.read()
	analogX = pad:analogX()
	analogY = pad:analogY()
	textString = Input(Controls.read())
	if pad:start() then
		break
	end
	if pad:select() then
		Wlan.init()
		Wlan.useConnectionConfig(1)
		Options()
	end
	
if selector == 1 then screen:blit(460,60,selectorp) to_input() end
if selector == 2 then screen:blit(460,90,selectorp) from_input() end
if selector == 3 then screen:blit(460,117,selectorp) subject_input() end
if selector == 4 then screen:blit(460,155,selectorp) message_input() end

if pad:down() then selector=selector + 1 delay(500) end
if pad:up() then selector=selector - 1 delay(500) end
if selector > 4 then selector = 1 end
if selector < 1 then selector = 4 end

if keyopt == 1 then screen:blit(10,10,keys) danzeffopt = keys_s selectpad = standletters end
if keyopt == 2 then screen:blit(10,10,keys_c) danzeffopt = keys_s_c selectpad = capletters end
if keyopt == 3 then screen:blit(10,10,nums) danzeffopt = nums_s selectpad = numbers end
if keyopt == 4 then screen:blit(10,10,nums_c) danzeffopt = nums_s_c selectpad = specialchar end

if pad:r() then keyopt = keyopt + 1 delay(500) end
if pad:l() then keyopt = keyopt - 1 delay(500) end
if keyopt > 4 then keyopt = 1 end
if keyopt < 1 then keyopt = 4 end

danzeff()

screen:print(220,65,to,black)
screen:print(244,94,from,black)
screen:print(260,122,subject ,black)
screen:print(16,182,message,black)

screen.waitVblankStart()
screen.flip()
end